//gendert am 27.12.2000
// v0.1
//NEU: 27.12.00  setData() nderung bei leerem Vector (Layout Bug bei UseCases)
package utopp.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import utopp.modell.*;
import utopp.modell.event.*;

/* Diese Klasse kann ohne abgeleitet zu werden, direkt fr alle Flle benutzt
   werden, es sei denn man braucht mehr Funktionalitt. bergeben wird ein Vektor
   mit Datenobjekten, deren 'toString()' Methode so berschrieben ist, das der
   zurckgegebene String als Darstellung in der Liste benutzt werden kann (Prinzip
   von JList). Und schlielich wird noch ein von DataPanel-abgeleitetes Objekt bergeben,
   das wei, wie diese Daten dargestellt werden sollen und auch passende Objekte 
   zurckliefern kann (getData()), 
 */
public class ListControlPanel extends DataPanel implements ListSelectionListener, PanelDataChangeListener
{  
  protected JList jliListe;
  protected JPanel jpListPanel;
  protected DataPanel jpData;
  protected UmlObjectListe data;
  protected JPopupMenu jpmList;
  
  public ListControlPanel(UmlObjectListe data, DataPanel dpData){
  
    super();
	this.jpData = dpData;
	this.data = data;
	initGUI();
  }
    	   
  public void valueChanged(ListSelectionEvent e){
  	Object h = jliListe.getSelectedValue();
	if (h!=null)
  	  jpData.setData(h);  
  }
  
  public void setSelected(Object item){
    jliListe.setListData(data);
	jliListe.setSelectedValue(item, true);
  };
  
  public void dataChanged(Object neu)
  {
  	Object h = jliListe.getSelectedValue();
        if (h!=null && h==jpData.getShowing()){
          jpData.getData(h);
	  jliListe.setSelectedValue(h,true);
          }
  } 	  
	
  public void actionPerformed(ActionEvent e){
  
    if (e.getActionCommand().equals("Neu")) 
	{  
	   Object h = jpData.getDummy();
	   addItem(data.indexOf(jliListe.getSelectedValue()),h);
	   setSelected(h);
	}
	else if (e.getActionCommand().equals("Lschen") &&
	   JOptionPane.showConfirmDialog(this,"Eintrag wirklich lschen",
	  "Lschen",JOptionPane.YES_NO_OPTION, 
	  JOptionPane.WARNING_MESSAGE)==0 && data.remove(jliListe.getSelectedValue()))
                {
   		setSelected(getToShow());	
        if (dul!=null)
		  dul.updateDiagram();
                }
  }
  
  public Object getToShow(){
  	return data.isEmpty()?null:data.firstElement();
  }
 
  
  private void addItem(int i, Object item)
  {	 
  	try{
	  if (i>=0)
	     data.addWithCheck(i,item);
	  else
	     data.addWithCheck(item);
	} catch (ElementExistiertException eee){System.out.println("Fehler"+eee.getMessage());
	}   

  }
  
  public void setData(Object data){
    this.data =(UmlObjectListe) data;
    if(this.data.isEmpty())//NEU: 27.12.00 fgt bei leerem Vector einen Dummy ein
      {
      try{
        this.data.addWithCheck(jpData.getDummy());}
      catch(ElementExistiertException e){}
      }
	setSelected(getToShow());
  }
  
  public void getData(Object item){
  	UmlObjectListe h = (UmlObjectListe) item;
	h.clear();
	for (int i=0;i<data.size();i++)
	  h.add(data.get(i));	
  }
  
  public Object getObject(){
    return data;
  }
  
  public Object getDummy(){
    return new UmlObjectListe();
  }
  
// GUI 	
  public void add(Container target, Component c, GridBagConstraints gbc, int x, int y, int w, int h, int wx, int wy)
    {
    gbc.gridx = x;
    gbc.gridy = y;
    gbc.gridwidth = w;
    gbc.gridheight = h;
    gbc.weightx = wx;
    gbc.weighty = wy;
    target.add(c, gbc);
    }
  protected void initGUI()
    {
    this.setLayout(new GridBagLayout());
    GridBagConstraints myGBC = new GridBagConstraints();
    myGBC.fill = GridBagConstraints.BOTH;
	
	jpmList = ComponentFactory.getListPopupMenu(this);
	  
    jliListe = new JList(data);
    jliListe.addListSelectionListener(this);	
	jliListe.addMouseListener(new PopupListener());
	
    jpListPanel = new JPanel(new GridBagLayout());	
    add(jpListPanel,ComponentFactory.getJButton("Neu", this),myGBC,0,0,1,1,100,0);
    add(jpListPanel,ComponentFactory.getJButton("Lschen", this),myGBC,0,1,1,1,100,0);
    add(jpListPanel,new JScrollPane(jliListe),myGBC,0,2,1,1,100,100);
	
    add(this,jpData,myGBC,1,0,1,1,100,100);
    add(this,jpListPanel,myGBC,0,0,1,1,0,100);
	
    setSelected(getToShow()); 
    jpData.addPanelDataChangeListener(this);
    }
	
    class PopupListener extends MouseAdapter
    {  
	  public void mouseReleased(MouseEvent e)
      {
    	if(e.isPopupTrigger())
            jpmList.show(e.getComponent(),e.getX(),e.getY());              
      }//end mouseReleased
	  
    }//end class ExitListener  
}