package utopp.gui.assoziationsframe;

import java.awt.*;
import javax.swing.*;
import utopp.gui.*;
import utopp.modell.*;

public class MultiAssDataPanel extends DataPanel
{
  MultiAssAllgPanel mapAllg;
  ListControlPanel lpcRollen;
  
  public MultiAssDataPanel()
  {
    super();
	initGUI();
	this.setBorder(BorderFactory.createTitledBorder("MultiAssoziation"));		 
  }
  
  public static void setKlassen(UmlKlassenListe klassen){
    RollenDataPanel.setKlassen(klassen);
  }
  
  public void setData(Object data)
  {
  	 UmlMultiAssoziation h = (UmlMultiAssoziation) data;
	 
	 this.mapAllg.setData(h);
	 this.lpcRollen.setData(h.getRollen());
	 
	 showing = data;
  }
  
  public void getData(Object item){
   
  	UmlMultiAssoziation h = (UmlMultiAssoziation) item;
	mapAllg.getData(h);
	h.setRollen((UmlRollenListe) lpcRollen.getObject());
  }
  
  public Object getObject(){
  	UmlMultiAssoziation h = (UmlMultiAssoziation) mapAllg.getObject();
	h.setRollen((UmlRollenListe) lpcRollen.getObject());
    return h;
  } 
  
  public Object getDummy(){
    return mapAllg.getDummy();
  }
	
  void initGUI()
  {
  	 
   GridBagConstraints myGBC = new GridBagConstraints();
   myGBC.fill = GridBagConstraints.BOTH;
   
   myGBC.insets = NORMAL; 
	
	mapAllg = new MultiAssAllgPanel();
	this.add(mapAllg, myGBC, 0,0,1,1,100,100);
	
	myGBC.insets = OBEN;
  	
	lpcRollen = new ListControlPanel(new UmlRollenListe(), new RollenDataPanel("Rollen"));
	this.add(lpcRollen, myGBC, 0,1,1,1,100,70);

	
  }

}