package utopp.gui.klassenframe;

import java.awt.*;
import javax.swing.*;
import utopp.gui.*;
import utopp.modell.*;

public class ParameterDataPanel extends DataPanel
{  
  JTextField jtfName;
  JComboBox jcobTyp;
  JTextField jtfInitialwert; 
				
  public ParameterDataPanel()
  {
    super();
	
	initGUI();		 
  }
  
  public void setData(Object data)
  {
  	 UmlParameter h = (UmlParameter) data;
     this.jtfName.setText(h.getName());
	 this.jtfInitialwert.setText(h.getInitialwert());
	 this.jcobTyp.setSelectedItem(h.getTyp());
	 showing = data; 
  }
  
  public Object getObject(){
    return (Object) new UmlParameter((String)jcobTyp.getSelectedItem(), 
							jtfName.getText(), jtfInitialwert.getText());
  
  }
 
  public void getData(Object item){
    UmlParameter h = (UmlParameter) item;
	h.setTyp((String)jcobTyp.getSelectedItem()); 
	h.setName(jtfName.getText());
	h.setInitialwert(jtfInitialwert.getText());
	
  
  }
  
  public Object getDummy(){
    return (Object) new UmlParameter("int","<name>","");
  }
	
  void initGUI()
    {
      //Einstellung des Layouts
    GridBagConstraints myGBC = new GridBagConstraints();
    myGBC.fill = GridBagConstraints.BOTH;
	
	myGBC.insets = NORMAL;
	
      add(new JLabel("Name"), myGBC,0,0,1,1,100,0);	        
      jtfName = new JTextField();
	  jtfName.addActionListener(this);
      add(jtfName, myGBC,1,0,1,1,100,0);
	  
  
      add(new JLabel("Typ"), myGBC,0,1,1,1,100,0);	  
      jcobTyp = ComponentFactory.getTypCombo();
	  jcobTyp.addActionListener(this);
      add(jcobTyp, myGBC,1,1,1,1,100,0);
	  
      add(new JLabel("Initialwert"), myGBC,0,2,1,1,100,0);	  
      jtfInitialwert = new JTextField();
	  jtfInitialwert.addActionListener(this);
      add(jtfInitialwert, myGBC,1,2,1,1,100,0);
	  
	  myGBC.insets = OBEN;
	  add(ComponentFactory.getJButton("bernehmen", this), myGBC, 0,3,1,1,100,0);
    }

}