package utopp.gui.usecaseframe;

import java.awt.*;
import javax.swing.*;

class MainTab extends JPanel
  {
  JLabel jlName;
  JTextField jtfName;
  JLabel jlAkteur;
  JTextField jtfAkteur;
  JLabel jlVorbedingung;
  JScrollPane jspVorbedingung;
  JTextArea jtaVorbedingung;
  JLabel jlNachbedingung;
  JScrollPane jspNachbedingung;
  JTextArea jtaNachbedingung;

  MainTab()
    {
    initGUI();
    }

  
  public void add(Component c, GridBagConstraints gbc, int x, int y, int w, int h, int wx, int wy)
    {
    gbc.gridx = x;
    gbc.gridy = y;
    gbc.gridwidth = w;
    gbc.gridheight = h;
    gbc.weightx = wx;
    gbc.weighty = wy;
    this.add(c, gbc);
    }

  void initGUI()
    {
      //Einstellung des Layouts
    GridBagLayout gblLayout = new GridBagLayout();
    this.setLayout(gblLayout);
    GridBagConstraints myGBC = new GridBagConstraints();
    myGBC.fill = GridBagConstraints.BOTH;
      //Hinzufgen der Komponenten
      //jlName
    jlName = new JLabel("Name:");
    add(jlName,myGBC,0,0,1,1,100,0);
      //jtfName
    jtfName = new JTextField();
    add(jtfName,myGBC,0,1,1,1,100,10);
      //jlAkteur
    jlAkteur = new JLabel("Akteur:");
    add(jlAkteur,myGBC,1,0,1,1,100,0);
      //jtfAkteur
    jtfAkteur = new JTextField();
    add(jtfAkteur,myGBC,1,1,1,1,100,10);
      //jlVorbedingung
    jlVorbedingung = new JLabel("Vorbedingung:");
    add(jlVorbedingung,myGBC,0,2,1,1,100,0);
      //Vorbedingung: Scrollpane + TextArea
    jtaVorbedingung = new JTextArea();
    jspVorbedingung = new JScrollPane(jtaVorbedingung);
    add(jspVorbedingung,myGBC,0,3,2,2,100,100);
      //jlNachbedingung
    jlNachbedingung = new JLabel("Nachbedingung:");
    add(jlNachbedingung,myGBC,0,5,1,1,100,0);
      //Nachbedingung: Scrollpane + TextArea
    jtaNachbedingung = new JTextArea();
    jspNachbedingung = new JScrollPane(jtaNachbedingung);
    add(jspNachbedingung,myGBC,0,6,2,2,100,100);
    }

  public String[] getData()
    {
    String[] aMT = new String[4];
    aMT[0]=jtfName.getText();
    aMT[1]=jtfAkteur.getText();
    aMT[2]=jtaVorbedingung.getText();
    aMT[3]=jtaNachbedingung.getText();
    return aMT;
    }
    
  public void setData(String[] data)
    {
    jtfName.setText(data[0]);
    jtfAkteur.setText(data[1]);
    jtaVorbedingung.setText(data[2]);
    jtaNachbedingung.setText(data[3]);
    }//end setData()

  String getNameText()
    {
    return jtfName.getText();
    }
 
  String getAkteurText()
    {
    return jtfAkteur.getText();
    }

  String getVorbedingungText()
    {
    return jtaVorbedingung.getText();
    }

  String getNachbedingungText()
    {
    return jtaNachbedingung.getText();
    }  

  void setNameText(String s)
    {
    jtfName.setText(s);
    }
 
  void setAkteurText(String s)
    {
    jtfAkteur.setText(s);
    }

  void setVorbedingungText(String s)
    {
    jtaVorbedingung.setText(s);
    }

  void setNachbedingungText(String s)
    {
    jtaNachbedingung.setText(s);
    }  

  }