package utopp.modell;

import java.io.*;
import java.text.*;

import utopp.xml.*;

public class Pflichtenheft extends UmlObject implements XmlDatenaustausch
{
	private String sBeschreibung="";
	private String sMusskriterien="";
	private String sWunschkriterien="";
	private String sAbgrenzungskriterien="";
	private String sAnwendungsbereiche="";
	private String sZielgruppen="";
	private String sBetriebsbedingungen="";
	private String sSoftware1="";
	private String sHardware1="";
	private String sOrgware1="";
	private String sSchnittstellen1="";
	private String sProduktleistungen="";
	private String sFunktionalitaet="";
	private String sZuverlaessigkeit="";
	private String sBenutzbarkeit="";
	private String sEffizienz="";
	private String sAenderbarkeit="";
	private String sTestszenarien="";
	private String sSoftware2="";
	private String sHardware2="";
	private String sOrgware2="";
	private String sSchnittstellen2="";
	private String sErgaenzungen="";
	
	public Pflichtenheft(){
	  super("Pflichtenheft");
	}
	
	public String getBeschreibung () 
	{
		return sBeschreibung;
	}

	public String getMusskriterien () 
	{
		return sMusskriterien;
	}

	public String getWunschkriterien () 
	{
		return sWunschkriterien;
	}

	public String getAbgrenzungskriterien () 
	{
		return sAbgrenzungskriterien;
	}

	public String getAnwendungsbereiche () 
	{
		return sAnwendungsbereiche;
	}

	public String getZielgruppen () 
	{
		return sZielgruppen;
	}
	
	public String getBetriebsbedingungen () 
	{
		return sBetriebsbedingungen;
	}
	
	public String getSoftware1 () 
	{
		return sSoftware1;
	}

	public String getHardware1 () 
	{
		return sHardware1;
	}

	public String getOrgware1 () 
	{
		return sOrgware1;
	}

	public String getSchnittstellen1 () 
	{
		return sSchnittstellen1;
	}

	public String getProduktleistungen () 
	{
		return sProduktleistungen;
	}

	public String getFunktionalitaet () 
	{
		return sFunktionalitaet;
	}

	public String getZuverlaessigkeit () 
	{
		return sZuverlaessigkeit;
	}

	public String getBenutzbarkeit () 
	{
		return sBenutzbarkeit;
	}

	public String getEffizienz () 
	{
		return sEffizienz;
	}

	public String getAenderbarkeit () 
	{
		return sAenderbarkeit;
	}

	public String getTestszenarien () 
	{
		return sTestszenarien;
	}

	public String getSoftware2 () 
	{
		return sSoftware2;
	}

	public String getHardware2 () 
	{
		return sHardware2;
	}

	public String getOrgware2 () 
	{
		return sOrgware2;
	}

	public String getSchnittstellen2 () 
	{
		return sSchnittstellen2;
	}

	public String getErgaenzungen () 
	{
		return sErgaenzungen;
	}

	public void setBeschreibung (String value) 
	{
		sBeschreibung = value;
	}

	public void setMusskriterien (String value) 
	{
		sMusskriterien = value;
	}

	public void setWunschkriterien (String value) 
	{
		sWunschkriterien = value;
	}

	public void setAbgrenzungskriterien (String value) 
	{
		sAbgrenzungskriterien = value;
	}

	public void setAnwendungsbereiche (String value) 
	{
		sAnwendungsbereiche = value;
	}

	public void setZielgruppen (String value) 
	{
		sZielgruppen = value;
	}
	
	public void setBetriebsbedingungen (String value){
	  sBetriebsbedingungen = value;
	}

	public void setSoftware1 (String value) 
	{
		sSoftware1 = value;
	}

	public void setHardware1 (String value) 
	{
		sHardware1 = value;
	}

	public void setOrgware1 (String value) 
	{
		sOrgware1 = value;
	}

	public void setSchnittstellen1 (String value) 
	{
		sSchnittstellen1 = value;
	}

	public void setProduktleistungen (String value) 
	{
		sProduktleistungen = value;
	}

	public void setFunktionalitaet (String value) 
	{
		sFunktionalitaet = value;
	}

	public void setZuverlaessigkeit (String value) 
	{
		sZuverlaessigkeit = value;
	}

	public void setBenutzbarkeit (String value) 
	{
		sBenutzbarkeit = value;
	}

	public void setEffizienz (String value) 
	{
		sEffizienz = value;
	}

	public void setAenderbarkeit (String value) 
	{
		sAenderbarkeit = value;
	}

	public void setTestszenarien (String value) 
	{
		sTestszenarien = value;
	}

	public void setSoftware2 (String value) 
	{
		sSoftware2 = value;
	}

	public void setHardware2 (String value) 
	{
		sHardware2 = value;
	}

	public void setOrgware2 (String value) 
	{
		sOrgware2 = value;
	}

	public void setSchnittstellen2 (String value) 
	{
		sSchnittstellen2 = value;
	}

	public void setErgaenzungen (String value) 
	{
		sErgaenzungen = value;
	}
	
	public void xmlWrite (XmlWriter o, int depth)  throws IOException
	{
	  o.writeTagLn("Pflichtenheft", depth);
	  o.writeTaggedValueLn("Beschreibung",sBeschreibung,depth+1);
	  o.writeTaggedValueLn("Musskriterien",sMusskriterien,depth+1);
	  o.writeTaggedValueLn("Wunschkriterien",sWunschkriterien,depth+1);
	  o.writeTaggedValueLn("Abgrenzungskriterien",sAbgrenzungskriterien,depth+1);
	  o.writeTaggedValueLn("Anwendungsbereiche",sAnwendungsbereiche,depth+1);
	  o.writeTaggedValueLn("Zielgruppen",sZielgruppen,depth+1);
	  o.writeTaggedValueLn("Betriebsbedingungen",sBetriebsbedingungen,depth+1);
	  o.writeTaggedValueLn("Software1",sSoftware1,depth+1);
	  o.writeTaggedValueLn("Hardware1",sHardware1,depth+1);
	  o.writeTaggedValueLn("Orgware1",sOrgware1,depth+1);
	  o.writeTaggedValueLn("Schnittstellen1",sSchnittstellen1,depth+1);
	  o.writeTaggedValueLn("Produktleistungen",sProduktleistungen,depth+1);
	  o.writeTaggedValueLn("Funktionalitaet",sFunktionalitaet,depth+1);
	  o.writeTaggedValueLn("Zuverlaessigkeit",sZuverlaessigkeit,depth+1);
	  o.writeTaggedValueLn("Benutzbarkeit",sBenutzbarkeit,depth+1);
	  o.writeTaggedValueLn("Effizienz",sEffizienz,depth+1);
	  o.writeTaggedValueLn("Aenderbarkeit",sAenderbarkeit,depth+1);
	  o.writeTaggedValueLn("Testszenarien",sTestszenarien,depth+1);
	  o.writeTaggedValueLn("Software2",sSoftware2,depth+1);
	  o.writeTaggedValueLn("Hardware2",sHardware2,depth+1);
	  o.writeTaggedValueLn("Orgware2",sOrgware2,depth+1);
	  o.writeTaggedValueLn("Schnittstellen2",sSchnittstellen2,depth+1);
	  o.writeTaggedValueLn("Ergaenzungen",sErgaenzungen,depth+1);
	  o.writeEndTagLn("Pflichtenheft", depth);

	};
	
	public void xmlRead (XmlReader i) throws IOException
	{
	  try{
	  while (i.ready())	
	  {
		ParseResult pr=i.getNext();
		int typ = pr.getState();
		String tag = pr.getTag();
		
		if (typ==3 && tag.equals("Pflichtenheft"))
		  break;
		if (typ == 2)  
		{
		    if (tag.equals("Beschreibung"))
		      sBeschreibung = i.getTagValue(tag);
		    else  
		    if (tag.equals("Musskriterien"))
		      sMusskriterien = i.getTagValue(tag);
		    else  
		    if (tag.equals("Wunschkriterien"))
		      sWunschkriterien = i.getTagValue(tag);
		    else  
		    if (tag.equals("Abgrenzungskriterien"))
		      sAbgrenzungskriterien = i.getTagValue(tag);
		    else  
		    if (tag.equals("Anwendungsbereiche"))
		      sAnwendungsbereiche = i.getTagValue(tag);
		    else  
		    if (tag.equals("Zielgruppen"))
		      sZielgruppen = i.getTagValue(tag);
			else			
			if (tag.equals("Betriebsbedingungen"))
			  sBetriebsbedingungen = i.getTagValue(tag);
		    else
			if (tag.equals("Software1"))
			  sSoftware1 = i.getTagValue(tag);
		    else
			if (tag.equals("Hardware1"))
			  sHardware1 = i.getTagValue(tag);
		    else
			if (tag.equals("Orgware1"))
			  sOrgware1 = i.getTagValue(tag);
		    else
			if (tag.equals("Schnittstellen1"))
			  sSchnittstellen1 = i.getTagValue(tag);
		    else
			if (tag.equals("Produktleistungen"))
			  sProduktleistungen = i.getTagValue(tag);
		    else
			if (tag.equals("Funktionalitaet"))
			  sFunktionalitaet = i.getTagValue(tag);
		    else
		    if (tag.equals("Aenderbarkeit"))
		      sAenderbarkeit = i.getTagValue(tag);
		    else
		    if (tag.equals("Zuverlaessigkeit"))
		      sZuverlaessigkeit = i.getTagValue(tag);
		    else			
		    if (tag.equals("Benutzbarkeit"))
		      sBenutzbarkeit = i.getTagValue(tag);
		    else			
			if (tag.equals("Effizienz"))
			  sEffizienz = i.getTagValue(tag);
		    else
			if (tag.equals("Testszenarien"))
			  sTestszenarien = i.getTagValue(tag);
		    else						
			if (tag.equals("Software2"))
			  sSoftware2 = i.getTagValue(tag);
		    else
			if (tag.equals("Hardware2"))
			  sHardware2 = i.getTagValue(tag);
		    else
			if (tag.equals("Orgware2"))
			  sOrgware2 = i.getTagValue(tag);
		    else
			if (tag.equals("Schnittstellen2"))
			  sSchnittstellen2 = i.getTagValue(tag);
		    else			
			if (tag.equals("Ergaenzungen"))
			  sErgaenzungen = i.getTagValue(tag);			  
		}	
		
	  } // while
	  
	  }
	  catch(ParseException pe){System.out.println(pe);};
	} //xmlRead	

}
