package utopp.diagram;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;
import utopp.gui.*;
import utopp.modell.*;
import utopp.modell.event.*;

public class DiagramCollection extends Vector
  {
  public DiagramCollection()
    {
    super();
    }
  
  public void addDiagram(Diagram d) throws ElementExistiertException
    {
    if(!(contains(d)))
      {
      addElement(d);
      }
    else
      throw new ElementExistiertException("FEHLER: class DiagramCollection: name invalid/exists.");
    }

  public boolean contains(Diagram d)
    {
    Iterator it2 = this.iterator();
    while(it2.hasNext())
      if(((Diagram)(it2.next())).getName().equals(d.getName()))
        return true;
    return false;
    }

  public Diagram getElementAt(int index) throws ElementExistiertNichtException
    {
    Iterator it1 = this.iterator();
    int i=0;
    while(it1.hasNext())
      {
      if(i==index)
        return (Diagram)it1.next();
      else
        {
        it1.next();
        i++;
        }
      }
    throw new ElementExistiertNichtException("DiagramCollection: Diagram not found.");
    }//end getElementAt(...)
  
  public String toString()
    {
    String returnString = new String();
    returnString+="\nAlle Diagramme in Collection:";
    Iterator it = this.iterator();
    while(it.hasNext())
      returnString+="\n  "+((Diagram)it.next()).getName();
    return returnString;
    }
  }//end class DiagramCollection