package utopp.gui.assoziationsframe;

import java.awt.*;
import javax.swing.*;
import utopp.gui.*;
import utopp.modell.*;

public class AssDataPanel extends DataPanel
{
  MultiAssDataPanel madMulti;
  BinaerAssDataPanel badBinaer;
  CardLayout c;
  JPanel ass;
  
  public AssDataPanel(PanelDataChangeListener l)
  { 
  	super(l);
	initGUI();		 
  }
  
  public AssDataPanel(){
    this(null);	
  }
  
  public static void setKlassen(UmlKlassenListe klassen){
    RollenDataPanel.setKlassen(klassen);
  }
  
  public void setData(Object data)
  {
  	 if (data instanceof UmlMultiAssoziation){ 
	     madMulti.setData(data);
	     c.first(ass);
  	 }
  	 else
  	 {
  	 	 badBinaer.setData(data);
  	 	 c.last(ass);	 	
  	 } 
     showing=data;
  }
  
  public void getData(Object item){
  	 if (item instanceof UmlMultiAssoziation)
	   madMulti.getData(item);
	 else
	   badBinaer.getData(item); 	 	
  }
  
  public Object getObject(){
    return (badBinaer.isVisible())?badBinaer.getObject():madMulti.getObject();
  } 
  
  public Object getDummy(){  
    return new UmlMultiAssoziation("","<name>","","");
  }
  	
  void initGUI()
  { 
	ass = new JPanel(c= new CardLayout());
	
  	madMulti = new MultiAssDataPanel();
  	ass.add(madMulti,"multi");
  	
  	badBinaer = new BinaerAssDataPanel();
  	ass.add(badBinaer,"binaer");
	
	GridBagConstraints myGBC = new GridBagConstraints();
	myGBC.fill = GridBagConstraints.BOTH;
		
	myGBC.insets = NORMAL;
  	
	this.add(ass, myGBC, 0,0,1,1,100,100);
	this.add(ComponentFactory.getJButton("Apply",this),myGBC, 0,1,1,1,100,0);
  }

}