package utopp.gui.assoziationsframe;

import java.awt.*;
import javax.swing.*;
import utopp.gui.*;
import utopp.modell.*;


public class MultiAssAllgPanel extends DataPanel
{

  JTextField jtfName;
  JComboBox jcobStereotyp;
  JTextArea jtaZusicherungen;
  JTextArea jtaEigenschaften;
  
  public MultiAssAllgPanel()
  {
    super();
	initGUI();		 
  }
  
  public void setData(Object data)
  {	 
     UmlMultiAssoziation h = (UmlMultiAssoziation) data;
	 this.jcobStereotyp.setSelectedItem(h.getStereotyp());
     this.jtfName.setText(h.getName()); 
	 this.jtaZusicherungen.setText(h.getZusicherung());
	 this.jtaEigenschaften.setText(h.getEigenschaften());
	 showing = data;
  }
  
  public void getData(Object item){
  	UmlMultiAssoziation h = (UmlMultiAssoziation) item;
    h.setStereotyp((String)jcobStereotyp.getSelectedItem()); 
	h.setName(jtfName.getText()); 
	h.setZusicherung(jtaZusicherungen.getText());
	h.setEigenschaften(jtaEigenschaften.getText());	
  };
  
  public Object getObject(){
  
    UmlMultiAssoziation h = new UmlMultiAssoziation(
	  (String)jcobStereotyp.getSelectedItem(), 
	  jtfName.getText(), 
	  jtaZusicherungen.getText(),
	  jtaEigenschaften.getText()	  
	  );
	return (Object) h;  
  
  }
  
  public Object getDummy(){
    return new UmlMultiAssoziation("", "<name>","","");  
  }
	
  void initGUI()
  { 
	    GridBagConstraints myGBC = new GridBagConstraints();
	    myGBC.fill = GridBagConstraints.BOTH;
		
		myGBC.insets = NORMAL;
	      //Hinzufgen der Komponenten
		 
	      add(new JLabel("Stereotyp"), myGBC, 0, 0, 2, 1, 100, 0);
	      jcobStereotyp = ComponentFactory.getStereotypCombo();
	      add(jcobStereotyp, myGBC, 2, 0, 2, 1, 50, 0);
		  
 	      add(new JLabel("Name"), myGBC, 4, 0, 2, 1, 100, 0);
	      jtfName = new JTextField();
	      add(jtfName, myGBC, 6,0, 2, 1, 100, 0);
		  
		  myGBC.insets = OBEN;
	      add(new JLabel("Zusicherungen"), myGBC, 0, 1, 3, 1, 100, 0);
  	      add(new JLabel("Eigenschaften"), myGBC, 4, 1, 3, 1, 100, 0);
		  
		  myGBC.insets = NORMAL;
	      jtaZusicherungen = new JTextArea(5,16);		  
	      add(new JScrollPane(jtaZusicherungen), myGBC, 0, 2, 4, 1, 50, 100);
		  
	      jtaEigenschaften = new JTextArea(5,16);		  
	      add(new JScrollPane(jtaEigenschaften), myGBC, 4, 2, 4, 1, 100, 100);
  }

}