//gendert am 27.12.00
//v0.1
//NEU: Apply Button, showing=data in setData(...)

package utopp.gui.klassenframe;

import java.awt.*;
import javax.swing.*;
import utopp.gui.*;
import utopp.modell.*;
import utopp.modell.event.*;

public class ClassDataPanel extends DataPanel
{
  
  ClassAllgPanel jpTabAllgemein;
  ListControlPanel jpTabMethoden;
  ListControlPanel jpTabAttribute;
  JButton jbApply;

  //Konstruktor1
  public ClassDataPanel(JFrame parent)
  {
    super();
	jpTabAllgemein = new ClassAllgPanel();
	jpTabAttribute = new ListControlPanel(new UmlAttributeListe(), new AttributeDataPanel());
    jpTabMethoden = new ListControlPanel(new UmlKlassenListe(), new MethodenDataPanel(parent));	
	
	initGUI();
  }
  
  //Konstruktor2
  public ClassDataPanel()
  {
    this(null);
  }
    
   protected void initGUI()
    {
	      //Das JTabbedPane (HauptContainer)
	    JTabbedPane jtpDialog = new JTabbedPane(JTabbedPane.TOP);
	      //Hinzufgen der Tabs zum jtpDialog
	    jtpDialog.addTab("Allgemeine", jpTabAllgemein);  		
	    jtpDialog.addTab("Attribute", jpTabAttribute); 
	    jtpDialog.addTab("Methoden", jpTabMethoden);
    
            jbApply= new JButton("Apply");
            jbApply.addActionListener(this);

		GridBagConstraints myGBC = new GridBagConstraints();
	    myGBC.fill = GridBagConstraints.BOTH;
		
	    this.add(jtpDialog,myGBC,0,0,1,1,100,100);
            this.add(jbApply,myGBC,0,1,1,1,100,0);
    }
    
  public void setData(Object data)
  {
  	 UmlKlasse h = (UmlKlasse) data;
	 
	 jpTabAllgemein.setData(data);
	 jpTabAttribute.setData(h.getAttribute());
     jpTabMethoden.setData(h.getMethoden());
  showing=data;//NEU 27.12.00  aktualisierte sich vorher nicht.
  };
  
  public void getData(Object item)
  {
 	UmlKlasse h = (UmlKlasse) item;
	jpTabAllgemein.getData(h);
	try{
      h.setMethoden((UmlMethodenListe) jpTabMethoden.getObject());
      h.setAttribute((UmlAttributeListe) jpTabAttribute.getObject());
	} catch (ElementExistiertException eee){};
  };
  
  
  public Object getObject()
  {
 	UmlKlasse h = (UmlKlasse) jpTabAllgemein.getObject();
		try{
      h.setMethoden((UmlMethodenListe) jpTabMethoden.getObject());
      h.setAttribute((UmlAttributeListe) jpTabAttribute.getObject());
	} catch (ElementExistiertException eee){};
	   	return (Object) h;
  };
  
  public Object getDummy(){
     return jpTabAllgemein.getDummy();  
  }    

}