package utopp.gui.usecaseframe;

import java.awt.*;
import javax.swing.*;


class AblaufTab extends JPanel
  {
  JLabel      jlAblauf;
  JScrollPane jspAblauf;
  JTextArea   jtaAblauf;

  AblaufTab()
    {
    initGUI();
    }

  public void add(Component c, GridBagConstraints gbc, int x, int y, int w, int h, int wx, int wy)
    {
    gbc.gridx = x;
    gbc.gridy = y;
    gbc.gridwidth = w;
    gbc.gridheight = h;
    gbc.weightx = wx;
    gbc.weighty = wy;
    this.add(c, gbc);
    }


  void initGUI()
    {
      //Layout Einstellungen
    GridBagLayout gblLayout = new GridBagLayout();
    this.setLayout(gblLayout);
    GridBagConstraints myGBC = new GridBagConstraints();
    myGBC.fill = GridBagConstraints.BOTH;
      //Hinzufgen der Komponenten
    jlAblauf  = new JLabel("Ablauf:");
    add(jlAblauf,myGBC,0,0,1,1,100,0);
    jtaAblauf = new JTextArea();
    jspAblauf = new JScrollPane(jtaAblauf);
    add(jspAblauf,myGBC,0,1,2,6,100,100);
    }

  public String[] getData()
    {
    String[] aAT = new String[1];
    aAT[0] = jtaAblauf.getText();
    return aAT;
    }

  public void setData(String[] data)
    {
    jtaAblauf.setText(data[0]);
    }//end setData

  String getAblaufText()
    {
    return jtaAblauf.getText();
    }

  void setAblaufText(String s)
    {
    jtaAblauf.setText(s);
    }
  }//end class AblaufTab